<template>
  <div style="height: calc(100vh - 280px);">
    <div class="search">
      <div class="search_thing">
        <div class="search_label">委托编号：</div>
        <div class="search_input"><el-input size="small" placeholder="请输入" clearable
            v-model="componentData.entity.entrustCode" @keyup.enter.native="refreshTable()"></el-input></div>
      </div>
      <div class="search_thing">
        <div class="search_label">样品名称：</div>
        <div class="search_input"><el-input size="small" placeholder="请输入" clearable
            v-model="componentData.entity.sampleName" @keyup.enter.native="refreshTable()"></el-input></div>
      </div>
      <div class="search_thing">
        <div class="search_label">样品型号：</div>
        <div class="search_input"><el-input size="small" placeholder="请输入" clearable
            v-model="componentData.entity.sampleModel" @keyup.enter.native="refreshTable()"></el-input></div>
      </div>
      <div class="search_thing">
        <div class="search_label">样品编号：</div>
        <div class="search_input"><el-input size="small" placeholder="请输入" clearable
            v-model="componentData.entity.sampleCode" @keyup.enter.native="refreshTable()"></el-input></div>
      </div>
      <div class="search_thing" style="margin-left: 20px;">
        <el-button size="small" @click="refresh()">重 置</el-button>
        <el-button size="small" type="primary" @click="refreshTable()">查 询</el-button>
      </div>
    </div>
    <div class="table">
      <ValueTable ref="ValueTable"
        :url="$api.insOrder.selectInsOrderParameter" :componentData="componentData"
        :upIndex="upIndex"  />
    </div>
  </div>
</template>

<script>
import ValueTable from '../../tool/value-table.vue'
export default {
  components: {
			ValueTable,
		},
  data() {
    return {
      componentData: {
        entity: {
          entrustCode: null,
          sample: null,
          sampleName: null,
          sampleModel: null,
          sampleCode: null,
          outEntrustCode: null,
          state: 1,
          name:null,
          engineering:null,
          production:null,
        },
        isIndex: true,
        showSelect: false,
        select: false,
        // selectMethod:'selectMethod',
        do: [{
          id: 'handleCreateReport',
          font: '生成报告',
          type: 'text',
          method: 'handleCreateReport',
          disabFun: (row, index) => {
            return row.insState == 5
          }
        }],
        tagField: {
          type: {
            select: [{
              value: 0,
              type: 'success',
              label: '普通'
            }, {
              value: 1,
              type: 'warning',
              label: '优先'
            }, {
              value: 2,
              type: 'danger',
              label: '紧急'
            }]
          },
          createUser: {
            select: []
          },
          orderType: {
            select: []
          },
          processing: {
            select: [{
              value: 1,
              label: '实验室处理'
            },{
              value: 0,
              label: '委托单位取回'
            }]
          },
          isLeave: {
            select: [{
              value: 1,
              label: '留样'
            },{
              value: 0,
              label: '不留样'
            }]
          },
          send: {
            select: [{
              value: 1,
              label: '自取'
            },{
              value: 0,
              label: '其他'
            }]
          }
        },
        selectField: {},
        requiredAdd: [],
        requiredUp: [],
        needSort: ['createTime', 'sendTime', 'type', 'appointed']
      },
      upIndex: 0,
      entityCopy: {}
    }
  },
  mounted() {
    this.entityCopy = this.HaveJson(this.componentData.entity)
    this.getPower()
  },
  methods:{
    // 权限分配
    getPower(radio) {
      let power = JSON.parse(sessionStorage.getItem('power'))
      let isReport = false
      for (var i = 0; i < power.length; i++) {
        if (power[i].menuMethod == 'isReport') {
          isReport = true
        }
      }
      if (!isReport) {
        this.componentData.do.splice(0, 1)
      }
    },
    refreshTable(e) {
      this.$refs['ValueTable'].selectList(e)
    },
    refresh() {
      this.componentData.entity = this.HaveJson(this.entityCopy)
      this.upIndex++
      this.refreshTable()
    },
    handleCreateReport(row){
      this.$confirm(`是否生成此委托单 ${row.entrustCode} 的总报告?`, "提示", {
            confirmButtonText: "生成",
            cancelButtonText: "不生成",
            type: "success",
            distinguishCancelAndClose: true,
            beforeClose: (action, instance, done) => {
            if (action === 'confirm') {
              instance.confirmButtonLoading = true;
              this.$axios.post(this.$api.insReport.isReport, {
                id:row.id,
                state:1
              }).then(res => {
                instance.confirmButtonLoading = false;
                if (res.code === 201) {
                  return
                }
                this.$message.success("已生成")
                this.refreshTable()
                done();
              }).catch(err => {
                console.log(err)
                instance.confirmButtonLoading = false;
              })
            } else if(action === 'cancel'){
              instance.cancelButtonLoading = true;
              this.$axios.post(this.$api.insReport.isReport, {
                id:row.id,
                state:0
              }).then(res => {
                instance.cancelButtonLoading = false;
                if (res.code === 201) {
                  return
                }
                this.refreshTable()
                done();
                this.$message.success("已取消生成")
              }).catch(err => {
                instance.cancelButtonLoading = false;
                console.log(err)
              })
            }else{
              done();
            }
          }
          }).then(() => {

          }).catch((e) => {
            console.log(e)
          })
    }
  }
}
</script>

<style scoped>
.search {
		background-color: #fff;
		height: 80px;
		display: flex;
		align-items: center;
    overflow: hidden;
	}

	.search_thing {
		display: flex;
		align-items: center;
		height: 50px;
    width: 230px;
	}

	.search_label {
		width: 90px;
		font-size: 14px;
		text-align: right;
	}

	.search_input {
		width: calc(100% - 90px);
	}

	.table {
		margin-top: 10px;
		background-color: #fff;
		height: 100%;
		padding: 20px;
	}
</style>
